diff -Naur tomato/release/src/router/pppd/pppd/sys-linux.c tomato121/release/src/router/pppd/pppd/sys-linux.c
--- tomato/release/src/router/pppd/pppd/sys-linux.c	2006-08-03 17:07:34.000000000 +1000
+++ tomato121/release/src/router/pppd/pppd/sys-linux.c	2008-04-22 21:44:05.000000000 +1000
@@ -1470,33 +1618,37 @@
     struct rtentry rt;
 
     if (defaultroute_exists(&rt) && strcmp(rt.rt_dev, ifname) != 0) {
-	u_int32_t old_gateway = SIN_ADDR(rt.rt_gateway);
-
-	if (old_gateway != gateway)
-	    error("not replacing existing default route to %s [%I]",
-		  rt.rt_dev, old_gateway);
+	if (rt.rt_flags & RTF_GATEWAY)
+	{
+	    error("not replacing existing default route via %I",
+		  SIN_ADDR(rt.rt_gateway));
+	}
+	else
+	{
+	    error("not replacing existing default route through %s",
+		  rt.rt_dev);
+	}
 	return 0;
     }
 
-    memset (&rt, '\0', sizeof (rt));
-    SET_SA_FAMILY (rt.rt_dst,     AF_INET);
-    SET_SA_FAMILY (rt.rt_gateway, AF_INET);
+    memset (&rt, 0, sizeof (rt));
+    SET_SA_FAMILY (rt.rt_dst, AF_INET);
+
+    rt.rt_dev = ifname;
 
     if (kernel_version > KVERSION(2,1,0)) {
 	SET_SA_FAMILY (rt.rt_genmask, AF_INET);
 	SIN_ADDR(rt.rt_genmask) = 0L;
     }
 
-    SIN_ADDR(rt.rt_gateway) = gateway;
-    
-    rt.rt_flags = RTF_UP | RTF_GATEWAY;
+    rt.rt_flags = RTF_UP;
     if (ioctl(sock_fd, SIOCADDRT, &rt) < 0) {
 	if ( ! ok_error ( errno ))
-	    error("default route ioctl(SIOCADDRT): %m(%d)", errno);
+	    error("default route ioctl(SIOCADDRT): %m");
 	return 0;
     }
 
-    default_route_gateway = gateway;
+    have_default_route = 1;
     return 1;
 }
 
@@ -1509,7 +1661,7 @@
 {
     struct rtentry rt;
 
-    default_route_gateway = 0;
+    have_default_route = 0;
 
     memset (&rt, '\0', sizeof (rt));
     SET_SA_FAMILY (rt.rt_dst,     AF_INET);
@@ -1520,13 +1672,11 @@
 	SIN_ADDR(rt.rt_genmask) = 0L;
     }
 
-    SIN_ADDR(rt.rt_gateway) = gateway;
-    
-    rt.rt_flags = RTF_UP | RTF_GATEWAY;
+    rt.rt_flags = RTF_UP;
     if (ioctl(sock_fd, SIOCDELRT, &rt) < 0 && errno != ESRCH) {
 	if (still_ppp()) {
 	    if ( ! ok_error ( errno ))
-		error("default route ioctl(SIOCDELRT): %m (%d)", errno);
+		error("default route ioctl(SIOCDELRT): %m");
 	    return 0;
 	}
     }
@@ -1546,7 +1696,7 @@
 
     if (has_proxy_arp == 0) {
 	memset (&arpreq, '\0', sizeof(arpreq));
-    
+
 	SET_SA_FAMILY(arpreq.arp_pa, AF_INET);
 	SIN_ADDR(arpreq.arp_pa) = his_adr;
 	arpreq.arp_flags = ATF_PERM | ATF_PUBL;
@@ -1563,7 +1713,7 @@
 
 	if (ioctl(sock_fd, SIOCSARP, (caddr_t)&arpreq) < 0) {
 	    if ( ! ok_error ( errno ))
-		error("ioctl(SIOCSARP): %m(%d)", errno);
+		error("ioctl(SIOCSARP): %m");
 	    return 0;
 	}
 	proxy_arp_addr = his_adr;
@@ -1575,7 +1725,9 @@
 		int fd = open(forw_path, O_WRONLY);
 		if (fd >= 0) {
 		    if (write(fd, "1", 1) != 1)
+		    {
 			error("Couldn't enable IP forwarding: %m");
+		    }
 		    close(fd);
 		}
 	    }
@@ -1604,13 +1756,15 @@
 
 	if (ioctl(sock_fd, SIOCDARP, (caddr_t)&arpreq) < 0) {
 	    if ( ! ok_error ( errno ))
-		warn("ioctl(SIOCDARP): %m(%d)", errno);
+	    {
+		warn("ioctl(SIOCDARP): %m");
+	    }
 	    return 0;
 	}
     }
     return 1;
 }
-     
+
 /********************************************************************
  *
  * get_ether_addr - get the hardware address of an interface on the
@@ -1624,20 +1778,21 @@
     struct ifreq *ifr, *ifend;
     u_int32_t ina, mask;
     char *aliasp;
-    struct ifreq ifreq;
+    struct ifreq ifreq, bestifreq;
     struct ifconf ifc;
     struct ifreq ifs[MAX_IFS];
-    
+
+    u_int32_t bestmask=0;
+    int found_interface = 0;
+
     ifc.ifc_len = sizeof(ifs);
     ifc.ifc_req = ifs;
     if (ioctl(sock_fd, SIOCGIFCONF, &ifc) < 0) {
 	if ( ! ok_error ( errno ))
-	    error("ioctl(SIOCGIFCONF): %m(%d)", errno);
+	    error("ioctl(SIOCGIFCONF): %m (line %d)", __LINE__);
 	return 0;
     }
 
-    SYSDEBUG ((LOG_DEBUG, "proxy arp: scanning %d interfaces for IP %s",
-		ifc.ifc_len / sizeof(struct ifreq), ip_ntoa(ipaddr)));
 /*
  * Scan through looking for an interface with an Internet
  * address on the same subnet as `ipaddr'.
@@ -1647,8 +1802,6 @@
 	if (ifr->ifr_addr.sa_family == AF_INET) {
 	    ina = SIN_ADDR(ifr->ifr_addr);
 	    strlcpy(ifreq.ifr_name, ifr->ifr_name, sizeof(ifreq.ifr_name));
-            SYSDEBUG ((LOG_DEBUG, "proxy arp: examining interface %s",
-			ifreq.ifr_name));
 /*
  * Check that the interface is up, and not point-to-point
  * nor loopback.
@@ -1662,22 +1815,26 @@
  * Get its netmask and check that it's on the right subnet.
  */
 	    if (ioctl(sock_fd, SIOCGIFNETMASK, &ifreq) < 0)
-	        continue;
+		continue;
 
 	    mask = SIN_ADDR(ifreq.ifr_addr);
-	    SYSDEBUG ((LOG_DEBUG, "proxy arp: interface addr %s mask %lx",
-			ip_ntoa(ina), ntohl(mask)));
 
 	    if (((ipaddr ^ ina) & mask) != 0)
-	        continue;
-	    break;
+		continue; /* no match */
+	    /* matched */
+	    if (mask >= bestmask) {
+		/* Compare using >= instead of > -- it is possible for
+		   an interface to have a netmask of 0.0.0.0 */
+		found_interface = 1;
+		bestifreq = ifreq;
+		bestmask = mask;
+	    }
 	}
     }
-    
-    if (ifr >= ifend)
-        return 0;
 
-    strlcpy(name, ifreq.ifr_name, namelen);
+    if (!found_interface) return 0;
+
+    strlcpy(name, bestifreq.ifr_name, namelen);
 
     /* trim off the :1 in eth0:1 */
     aliasp = strchr(name, ':');
@@ -1688,26 +1845,16 @@
 /*
  * Now get the hardware address.
  */
-    memset (&ifreq.ifr_hwaddr, 0, sizeof (struct sockaddr));
-    if (ioctl (sock_fd, SIOCGIFHWADDR, &ifreq) < 0) {
-        error("SIOCGIFHWADDR(%s): %m(%d)", ifreq.ifr_name, errno);
-        return 0;
+    memset (&bestifreq.ifr_hwaddr, 0, sizeof (struct sockaddr));
+    if (ioctl (sock_fd, SIOCGIFHWADDR, &bestifreq) < 0) {
+	error("SIOCGIFHWADDR(%s): %m", bestifreq.ifr_name);
+	return 0;
     }
 
     memcpy (hwaddr,
-	    &ifreq.ifr_hwaddr,
+	    &bestifreq.ifr_hwaddr,
 	    sizeof (struct sockaddr));
 
-    SYSDEBUG ((LOG_DEBUG,
-	   "proxy arp: found hwaddr %02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x",
-		(int) ((unsigned char *) &hwaddr->sa_data)[0],
-		(int) ((unsigned char *) &hwaddr->sa_data)[1],
-		(int) ((unsigned char *) &hwaddr->sa_data)[2],
-		(int) ((unsigned char *) &hwaddr->sa_data)[3],
-		(int) ((unsigned char *) &hwaddr->sa_data)[4],
-		(int) ((unsigned char *) &hwaddr->sa_data)[5],
-		(int) ((unsigned char *) &hwaddr->sa_data)[6],
-		(int) ((unsigned char *) &hwaddr->sa_data)[7]));
     return 1;
 }
 
@@ -1761,14 +1908,14 @@
     struct ifreq ifs[MAX_IFS];
 
     addr = ntohl(addr);
-    
+
     if (IN_CLASSA(addr))	/* determine network mask for address class */
 	nmask = IN_CLASSA_NET;
     else if (IN_CLASSB(addr))
 	    nmask = IN_CLASSB_NET;
     else
 	    nmask = IN_CLASSC_NET;
-    
+
     /* class D nets are disallowed by bad_ip_adrs */
     mask = netmask | htonl(nmask);
 /*
@@ -1778,10 +1925,12 @@
     ifc.ifc_req = ifs;
     if (ioctl(sock_fd, SIOCGIFCONF, &ifc) < 0) {
 	if ( ! ok_error ( errno ))
-	    warn("ioctl(SIOCGIFCONF): %m(%d)", errno);
+	{
+	    warn("ioctl(SIOCGIFCONF): %m (line %d)", __LINE__);
+	}
 	return mask;
     }
-    
+
     ifend = (struct ifreq *) (ifc.ifc_buf + ifc.ifc_len);
     for (ifr = ifc.ifc_req; ifr < ifend; ifr++) {
 /*
@@ -1798,7 +1947,7 @@
 	strlcpy(ifreq.ifr_name, ifr->ifr_name, sizeof(ifreq.ifr_name));
 	if (ioctl(sock_fd, SIOCGIFFLAGS, &ifreq) < 0)
 	    continue;
-	
+
 	if (((ifreq.ifr_flags ^ FLAGS_GOOD) & FLAGS_MASK) != 0)
 	    continue;
 /*
@@ -1825,7 +1974,7 @@
     *version      = (int) strtoul (buf, &endp, 10);
     *modification = 0;
     *patch        = 0;
-    
+
     if (endp != buf && *endp == '.') {
 	buf = endp + 1;
 	*modification = (int) strtoul (buf, &endp, 10);
@@ -1865,10 +2014,10 @@
      * Try to put the device into the PPP discipline.
      */
     if (ioctl(local_fd, TIOCSETD, &ppp_disc) < 0) {
-	error("ioctl(TIOCSETD(PPP)): %m(%d)", errno);
+	error("ioctl(TIOCSETD(PPP)): %m (line %d)", __LINE__);
     } else
 	ret = 1;
-    
+
     close(local_fd);
     close(mfd);
     return ret;
@@ -1888,7 +2037,7 @@
     int    my_version, my_modification, my_patch;
     int osmaj, osmin, ospatch;
 
-    no_ppp_msg = 
+    no_ppp_msg =
 	"This system lacks kernel support for PPP.  This could be because\n"
 	"the PPP kernel module could not be loaded, or because PPP was not\n"
 	"included in the kernel configuration.  If PPP was included as a\n"
@@ -1940,11 +2089,11 @@
 
 /*
  * Open a socket for doing the ioctl operations.
- */    
+ */
     s = socket(AF_INET, SOCK_DGRAM, 0);
     if (s < 0)
 	return 0;
-    
+
     strlcpy (ifr.ifr_name, "ppp0", sizeof (ifr.ifr_name));
     ok = ioctl(s, SIOCGIFFLAGS, (caddr_t) &ifr) >= 0;
 /*
@@ -1962,10 +2111,10 @@
  * Ensure that the hardware address is for PPP and not something else
  */
     if (ok)
-        ok = ioctl (s, SIOCGIFHWADDR, (caddr_t) &ifr) >= 0;
+	ok = ioctl (s, SIOCGIFHWADDR, (caddr_t) &ifr) >= 0;
 
     if (ok && ((ifr.ifr_hwaddr.sa_family & ~0xFF) != ARPHRD_PPP))
-        ok = 0;
+	ok = 0;
 
 /*
  *  This is the PPP device. Validate the version of the driver at this
@@ -1997,7 +2146,7 @@
 	    /* The version numbers must match */
 	    if (driver_version != my_version)
 		ok = 0;
-      
+
 	    /* The modification levels must be legal */
 	    if (driver_modification < 3) {
 		if (driver_modification >= 2) {
@@ -2041,11 +2190,8 @@
     utmpname(_PATH_UTMP);
     setutent();
     while ((utp = getutent()) && (utp->ut_pid != mypid))
-        /* nothing */;
+	/* nothing */;
 
-    /* Is this call really necessary? There is another one after the 'put' */
-    endutent();
-    
     if (utp)
 	memcpy(&ut, utp, sizeof(ut));
     else
@@ -2054,7 +2200,7 @@
 
     if (ut.ut_id[0] == 0)
 	strncpy(ut.ut_id, line + 3, sizeof(ut.ut_id));
-	
+
     strncpy(ut.ut_user, name, sizeof(ut.ut_user));
     strncpy(ut.ut_line, line, sizeof(ut.ut_line));
 
@@ -2071,7 +2217,7 @@
     if (ipcp_protent.enabled_flag && ipcp_hisoptions[0].neg_addr)
 	memcpy(&ut.ut_addr, (char *) &ipcp_hisoptions[0].hisaddr,
 		 sizeof(ut.ut_addr));
-	
+
     /* CL: Makes sure that the logout works */
     if (*host == 0 && *name==0)
 	ut.ut_host[0]=0;
@@ -2089,7 +2235,9 @@
 	flock(wtmp, LOCK_EX);
 
 	if (write (wtmp, (char *)&ut, sizeof(ut)) != sizeof(ut))
+	{
 	    warn("error writing %s: %m", _PATH_WTMP);
+	}
 
 	flock(wtmp, LOCK_UN);
 
@@ -2106,21 +2254,18 @@
 
 int sifvjcomp (int u, int vjcomp, int cidcomp, int maxcid)
 {
-    u_int x = get_flags(ppp_dev_fd);
+	u_int x;
 
-    if (vjcomp) {
-        if (ioctl (ppp_dev_fd, PPPIOCSMAXCID, (caddr_t) &maxcid) < 0) {
-	    if (! ok_error (errno))
-		error("ioctl(PPPIOCSMAXCID): %m(%d)", errno);
-	    vjcomp = 0;
+	if (vjcomp) {
+		if (ioctl(ppp_dev_fd, PPPIOCSMAXCID, (caddr_t) &maxcid) < 0)
+			error("Couldn't set up TCP header compression: %m");
+		vjcomp = 0;
 	}
-    }
 
-    x = vjcomp  ? x | SC_COMP_TCP     : x &~ SC_COMP_TCP;
-    x = cidcomp ? x & ~SC_NO_TCP_CCID : x | SC_NO_TCP_CCID;
-    set_flags (ppp_dev_fd, x);
+	x = (vjcomp? SC_COMP_TCP: 0) | (cidcomp? 0: SC_NO_TCP_CCID);
+	modify_flags(ppp_dev_fd, SC_COMP_TCP|SC_NO_TCP_CCID, x);
 
-    return 1;
+	return 1;
 }
 
 /********************************************************************
@@ -2136,14 +2281,14 @@
     strlcpy(ifr.ifr_name, ifname, sizeof (ifr.ifr_name));
     if (ioctl(sock_fd, SIOCGIFFLAGS, (caddr_t) &ifr) < 0) {
 	if (! ok_error (errno))
-	    error("ioctl (SIOCGIFFLAGS): %m(%d)", errno);
+	    error("ioctl (SIOCGIFFLAGS): %m (line %d)", __LINE__);
 	return 0;
     }
 
     ifr.ifr_flags |= (IFF_UP | IFF_POINTOPOINT);
     if (ioctl(sock_fd, SIOCSIFFLAGS, (caddr_t) &ifr) < 0) {
 	if (! ok_error (errno))
-	    error("ioctl(SIOCSIFFLAGS): %m(%d)", errno);
+	    error("ioctl(SIOCSIFFLAGS): %m (line %d)", __LINE__);
 	return 0;
     }
     if_is_up++;
@@ -2168,7 +2313,7 @@
     strlcpy(ifr.ifr_name, ifname, sizeof (ifr.ifr_name));
     if (ioctl(sock_fd, SIOCGIFFLAGS, (caddr_t) &ifr) < 0) {
 	if (! ok_error (errno))
-	    error("ioctl (SIOCGIFFLAGS): %m(%d)", errno);
+	    error("ioctl (SIOCGIFFLAGS): %m (line %d)", __LINE__);
 	return 0;
     }
 
@@ -2176,7 +2321,7 @@
     ifr.ifr_flags |= IFF_POINTOPOINT;
     if (ioctl(sock_fd, SIOCSIFFLAGS, (caddr_t) &ifr) < 0) {
 	if (! ok_error (errno))
-	    error("ioctl(SIOCSIFFLAGS): %m(%d)", errno);
+	    error("ioctl(SIOCSIFFLAGS): %m (line %d)", __LINE__);
 	return 0;
     }
     return 1;
@@ -2190,15 +2335,15 @@
 int sifaddr (int unit, u_int32_t our_adr, u_int32_t his_adr,
 	     u_int32_t net_mask)
 {
-    struct ifreq   ifr; 
+    struct ifreq   ifr;
     struct rtentry rt;
-    
+
     memset (&ifr, '\0', sizeof (ifr));
     memset (&rt,  '\0', sizeof (rt));
-    
-    SET_SA_FAMILY (ifr.ifr_addr,    AF_INET); 
-    SET_SA_FAMILY (ifr.ifr_dstaddr, AF_INET); 
-    SET_SA_FAMILY (ifr.ifr_netmask, AF_INET); 
+
+    SET_SA_FAMILY (ifr.ifr_addr,    AF_INET);
+    SET_SA_FAMILY (ifr.ifr_dstaddr, AF_INET);
+    SET_SA_FAMILY (ifr.ifr_netmask, AF_INET);
 
     strlcpy (ifr.ifr_name, ifname, sizeof (ifr.ifr_name));
 /*
@@ -2208,12 +2353,12 @@
     if (ioctl(sock_fd, SIOCSIFADDR, (caddr_t) &ifr) < 0) {
 	if (errno != EEXIST) {
 	    if (! ok_error (errno))
-		error("ioctl(SIOCSIFADDR): %m(%d)", errno);
+		error("ioctl(SIOCSIFADDR): %m (line %d)", __LINE__);
 	}
-        else {
+	else {
 	    warn("ioctl(SIOCSIFADDR): Address already exists");
 	}
-        return (0);
+	return (0);
     }
 /*
  *  Set the gateway address
@@ -2221,9 +2366,9 @@
     SIN_ADDR(ifr.ifr_dstaddr) = his_adr;
     if (ioctl(sock_fd, SIOCSIFDSTADDR, (caddr_t) &ifr) < 0) {
 	if (! ok_error (errno))
-	    error("ioctl(SIOCSIFDSTADDR): %m(%d)", errno); 
+	    error("ioctl(SIOCSIFDSTADDR): %m (line %d)", __LINE__);
 	return (0);
-    } 
+    }
 /*
  *  Set the netmask.
  *  For recent kernels, force the netmask to 255.255.255.255.
@@ -2234,9 +2379,9 @@
 	SIN_ADDR(ifr.ifr_netmask) = net_mask;
 	if (ioctl(sock_fd, SIOCSIFNETMASK, (caddr_t) &ifr) < 0) {
 	    if (! ok_error (errno))
-		error("ioctl(SIOCSIFNETMASK): %m(%d)", errno); 
+		error("ioctl(SIOCSIFNETMASK): %m (line %d)", __LINE__);
 	    return (0);
-	} 
+	}
     }
 /*
  *  Add the device route
@@ -2257,7 +2402,7 @@
 
 	if (ioctl(sock_fd, SIOCADDRT, &rt) < 0) {
 	    if (! ok_error (errno))
-		error("ioctl(SIOCADDRT) device route: %m(%d)", errno);
+		error("ioctl(SIOCADDRT) device route: %m (line %d)", __LINE__);
 	    return (0);
 	}
     }
@@ -2314,7 +2459,7 @@
 
 	if (ioctl(sock_fd, SIOCDELRT, &rt) < 0 && errno != ESRCH) {
 	    if (still_ppp() && ! ok_error (errno))
-		error("ioctl(SIOCDELRT) device route: %m(%d)", errno);
+		error("ioctl(SIOCDELRT) device route: %m (line %d)", __LINE__);
 	    return (0);
 	}
     }
@@ -2323,10 +2468,10 @@
     memset(&ifr, 0, sizeof(ifr));
     SET_SA_FAMILY(ifr.ifr_addr, AF_INET);
     strlcpy(ifr.ifr_name, ifname, sizeof(ifr.ifr_name));
-    
+
     if (ioctl(sock_fd, SIOCSIFADDR, (caddr_t) &ifr) < 0) {
 	if (! ok_error (errno)) {
-	    error("ioctl(SIOCSIFADDR): %m(%d)", errno);
+	    error("ioctl(SIOCSIFADDR): %m (line %d)", __LINE__);
 	    return 0;
 	}
     }
@@ -2338,7 +2483,7 @@
 
 #ifdef INET6
 /********************************************************************
- * 
+ *
  * sif6addr - Config the interface with an IPv6 link-local address
  */
 int sif6addr (int unit, eui64_t our_eui64, eui64_t his_eui64)
@@ -2355,10 +2500,10 @@
     memset(&ifr, 0, sizeof (ifr));
     strlcpy(ifr.ifr_name, ifname, sizeof(ifr.ifr_name));
     if (ioctl(sock6_fd, SIOCGIFINDEX, (caddr_t) &ifr) < 0) {
-	error("sif6addr: ioctl(SIOCGIFINDEX): %m (%d)", errno);
+	error("sif6addr: ioctl(SIOCGIFINDEX): %m (line %d)", __LINE__);
 	return 0;
     }
-    
+
     /* Local interface */
     memset(&ifr6, 0, sizeof(ifr6));
     IN6_LLADDR_FROM_EUI64(ifr6.ifr6_addr, our_eui64);
@@ -2366,10 +2511,10 @@
     ifr6.ifr6_prefixlen = 10;
 
     if (ioctl(sock6_fd, SIOCSIFADDR, &ifr6) < 0) {
-	error("sif6addr: ioctl(SIOCSIFADDR): %m (%d)", errno);
+	error("sif6addr: ioctl(SIOCSIFADDR): %m (line %d)", __LINE__);
 	return 0;
     }
-    
+
     /* Route to remote host */
     memset(&rt6, 0, sizeof(rt6));
     IN6_LLADDR_FROM_EUI64(rt6.rtmsg_dst, his_eui64);
@@ -2377,9 +2522,9 @@
     rt6.rtmsg_dst_len = 10;
     rt6.rtmsg_ifindex = ifr.ifr_ifindex;
     rt6.rtmsg_metric = 1;
-    
+
     if (ioctl(sock6_fd, SIOCADDRT, &rt6) < 0) {
-	error("sif6addr: ioctl(SIOCADDRT): %m (%d)", errno);
+	error("sif6addr: ioctl(SIOCADDRT): %m (line %d)", __LINE__);
 	return 0;
     }
 
@@ -2404,10 +2549,10 @@
     memset(&ifr, 0, sizeof(ifr));
     strlcpy(ifr.ifr_name, ifname, sizeof(ifr.ifr_name));
     if (ioctl(sock6_fd, SIOCGIFINDEX, (caddr_t) &ifr) < 0) {
-	error("cif6addr: ioctl(SIOCGIFINDEX): %m (%d)", errno);
+	error("cif6addr: ioctl(SIOCGIFINDEX): %m (line %d)", __LINE__);
 	return 0;
     }
-    
+
     memset(&ifr6, 0, sizeof(ifr6));
     IN6_LLADDR_FROM_EUI64(ifr6.ifr6_addr, our_eui64);
     ifr6.ifr6_ifindex = ifr.ifr_ifindex;
@@ -2416,12 +2561,12 @@
     if (ioctl(sock6_fd, SIOCDIFADDR, &ifr6) < 0) {
 	if (errno != EADDRNOTAVAIL) {
 	    if (! ok_error (errno))
-		error("cif6addr: ioctl(SIOCDIFADDR): %m (%d)", errno);
+		error("cif6addr: ioctl(SIOCDIFADDR): %m (line %d)", __LINE__);
 	}
-        else {
+	else {
 	    warn("cif6addr: ioctl(SIOCDIFADDR): No such address");
 	}
-        return (0);
+	return (0);
     }
     return 1;
 }
@@ -2455,10 +2600,14 @@
 #ifdef TIOCSPTLCK
 	    ptn = 0;
 	    if (ioctl(mfd, TIOCSPTLCK, &ptn) < 0)
+	    {
 		warn("Couldn't unlock pty slave %s: %m", pty_name);
+	    }
 #endif
 	    if ((sfd = open(pty_name, O_RDWR | O_NOCTTY)) < 0)
+	    {
 		warn("Couldn't open pty slave %s: %m", pty_name);
+	    }
 	}
     }
 #endif /* TIOCGPTN */
@@ -2495,9 +2644,13 @@
 	tios.c_oflag  = 0;
 	tios.c_lflag  = 0;
 	if (tcsetattr(sfd, TCSAFLUSH, &tios) < 0)
+	{
 	    warn("couldn't set attributes on pty: %m");
+	}
     } else
+    {
 	warn("couldn't get attributes on pty: %m");
+    }
 
     return 1;
 }
@@ -2517,7 +2670,7 @@
 	/* allocate ourselves a ppp unit */
 	if (make_ppp_unit() < 0)
 	    die(1);
-	set_flags(ppp_dev_fd, SC_LOOP_TRAFFIC);
+	modify_flags(ppp_dev_fd, 0, SC_LOOP_TRAFFIC);
 	set_kdebugflag(kdebugflag);
 	ppp_fd = -1;
 	return ppp_dev_fd;
@@ -2525,27 +2678,30 @@
 
     if (!get_pty(&master_fd, &slave_fd, loop_name, 0))
 	fatal("No free pty for loopback");
-    SYSDEBUG(("using %s for loopback", loop_name));
 
     set_ppp_fd(slave_fd);
 
     flags = fcntl(master_fd, F_GETFL);
     if (flags == -1 ||
 	fcntl(master_fd, F_SETFL, flags | O_NONBLOCK) == -1)
-	warn("couldn't set master loopback to nonblock: %m(%d)", errno);
-
+	{
+	warn("couldn't set master loopback to nonblock: %m");
+	}
     flags = fcntl(ppp_fd, F_GETFL);
     if (flags == -1 ||
 	fcntl(ppp_fd, F_SETFL, flags | O_NONBLOCK) == -1)
-	warn("couldn't set slave loopback to nonblock: %m(%d)", errno);
-
+	{
+	warn("couldn't set slave loopback to nonblock: %m");
+	}
     if (ioctl(ppp_fd, TIOCSETD, &ppp_disc) < 0)
-	fatal("ioctl(TIOCSETD): %m(%d)", errno);
+    {
+	fatal("ioctl(TIOCSETD): %m (line %d)", __LINE__);
+    }
 /*
  * Find out which interface we were given.
  */
     if (ioctl(ppp_fd, PPPIOCGUNIT, &ifunit) < 0)
-	fatal("ioctl(PPPIOCGUNIT): %m(%d)", errno);
+	fatal("ioctl(PPPIOCGUNIT): %m (line %d)", __LINE__);
 /*
  * Enable debug in the driver if requested.
  */
@@ -2556,33 +2712,6 @@
 
 /********************************************************************
  *
- * restore_loop - reattach the ppp unit to the loopback.
- *
- * The kernel ppp driver automatically reattaches the ppp unit to
- * the loopback if the serial port is set to a line discipline other
- * than ppp, or if it detects a modem hangup.  The former will happen
- * in disestablish_ppp if the latter hasn't already happened, so we
- * shouldn't need to do anything.
- *
- * Just to be sure, set the real serial port to the normal discipline.
- */
-
-static void
-restore_loop(void)
-{
-    looped = 1;
-    if (new_style_driver) {
-	set_flags(ppp_dev_fd, get_flags(ppp_dev_fd) | SC_LOOP_TRAFFIC);
-	return;
-    }
-    if (ppp_fd != slave_fd) {
-	(void) ioctl(ppp_fd, TIOCSETD, &tty_disc);
-	set_ppp_fd(slave_fd);
-    }
-}
-
-/********************************************************************
- *
  * sifnpmode - Set the mode for handling packets for a given NP.
  */
 
@@ -2598,8 +2727,7 @@
     npi.mode     = mode;
     if (ioctl(ppp_dev_fd, PPPIOCSNPMODE, (caddr_t) &npi) < 0) {
 	if (! ok_error (errno))
-	    error("ioctl(PPPIOCSNPMODE, %d, %d): %m (%d)",
-		   proto, mode, errno);
+	    error("ioctl(PPPIOCSNPMODE, %d, %d): %m", proto, mode);
 	return 0;
     }
     return 1;
@@ -2616,14 +2744,14 @@
     int    result = 1;
 
 #ifdef IPX_CHANGE
-    int    skfd; 
+    int    skfd;
     struct ifreq         ifr;
     struct sockaddr_ipx *sipx = (struct sockaddr_ipx *) &ifr.ifr_addr;
 
     skfd = socket (AF_IPX, SOCK_DGRAM, 0);
-    if (skfd < 0) { 
+    if (skfd < 0) {
 	if (! ok_error (errno))
-	    dbglog("socket(AF_IPX): %m (%d)", errno);
+	    dbglog("socket(AF_IPX): %m (line %d)", __LINE__);
 	result = 0;
     }
     else {
@@ -2643,7 +2771,7 @@
 	    result = 0;
 	    if (errno != EEXIST) {
 		if (! ok_error (errno))
-		    dbglog("ioctl(SIOCSIFADDR, CRTITF): %m (%d)", errno);
+		    dbglog("ioctl(SIOCSIFADDR, CRTITF): %m (line %d)", __LINE__);
 	    }
 	    else {
 		warn("ioctl(SIOCSIFADDR, CRTITF): Address already exists");
@@ -2667,14 +2795,14 @@
     int    result = 1;
 
 #ifdef IPX_CHANGE
-    int    skfd; 
+    int    skfd;
     struct ifreq         ifr;
     struct sockaddr_ipx *sipx = (struct sockaddr_ipx *) &ifr.ifr_addr;
 
     skfd = socket (AF_IPX, SOCK_DGRAM, 0);
-    if (skfd < 0) { 
+    if (skfd < 0) {
 	if (! ok_error (errno))
-	    dbglog("socket(AF_IPX): %m (%d)", errno);
+	    dbglog("socket(AF_IPX): %m (line %d)", __LINE__);
 	result = 0;
     }
     else {
@@ -2689,7 +2817,7 @@
  */
 	if (ioctl(skfd, SIOCSIFADDR, (caddr_t) &ifr) < 0) {
 	    if (! ok_error (errno))
-		info("ioctl(SIOCSIFADDR, IPX_DLTITF): %m (%d)", errno);
+		info("ioctl(SIOCSIFADDR, IPX_DLTITF): %m (line %d)", __LINE__);
 	    result = 0;
 	}
 	close (skfd);
@@ -2729,7 +2857,8 @@
 
     if (ipxcp_protent.enabled_flag) {
 	struct stat stat_buf;
-        if ((path = path_to_procfs("/net/ipx_interface")) == 0
+	if (  ((path = path_to_procfs("/net/ipx/interface")) == NULL
+	    && (path = path_to_procfs("/net/ipx_interface")) == NULL)
 	    || lstat(path, &stat_buf) < 0) {
 	    error("IPX support is not present in the kernel\n");
 	    ipxcp_protent.enabled_flag = 0;
@@ -2748,3 +2877,51 @@
     }
     return 1;
 }
+
+#ifdef INET6
+/*
+ * ether_to_eui64 - Convert 48-bit Ethernet address into 64-bit EUI
+ *
+ * convert the 48-bit MAC address of eth0 into EUI 64. caller also assumes
+ * that the system has a properly configured Ethernet interface for this
+ * function to return non-zero.
+ */
+int
+ether_to_eui64(eui64_t *p_eui64)
+{
+    struct ifreq ifr;
+    int skfd;
+    const unsigned char *ptr;
+
+    skfd = socket(PF_INET6, SOCK_DGRAM, 0);
+    if(skfd == -1)
+    {
+        warn("could not open IPv6 socket");
+        return 0;
+    }
+
+    strcpy(ifr.ifr_name, "eth0");
+    if(ioctl(skfd, SIOCGIFHWADDR, &ifr) < 0)
+    {
+        close(skfd);
+        warn("could not obtain hardware address for eth0");
+        return 0;
+    }
+    close(skfd);
+
+    /*
+     * And convert the EUI-48 into EUI-64, per RFC 2472 [sec 4.1]
+     */
+    ptr = ifr.ifr_hwaddr.sa_data;
+    p_eui64->e8[0] = ptr[0] | 0x02;
+    p_eui64->e8[1] = ptr[1];
+    p_eui64->e8[2] = ptr[2];
+    p_eui64->e8[3] = 0xFF;
+    p_eui64->e8[4] = 0xFE;
+    p_eui64->e8[5] = ptr[3];
+    p_eui64->e8[6] = ptr[4];
+    p_eui64->e8[7] = ptr[5];
+
+    return 1;
+}
+#endif
